//
//  THIS CODE WILL NOT COMPILE.
//  ONLY USE FUNCTIONS FOR REFERENCE.
//
//  Created by Fredrik Alvenes on 10.06.13.
//  Copyright (c) 2013 Fredrik Alvenes. All rights reserved.
//


#include <asf.h>
#include <led.h>
#include <stdio.h>
#include <math.h>

#define PI (3.141592653589793)



/************************   PROTOTYPES   ************************/

struct quaternion {
    float eta;
    float eps1;
    float eps2;
    float eps3;
};

struct vector {
    float x;
    float y;
    float z;
};


struct Euler_quat_storage_struct{
	float    eta;
	float    eps1;
	float    eps2;
	float	 eps3;
	float timestamp;
};

struct Euler_vector_storage_struct{
	float x;
	float y;
	float z;
	float timestamp;
};

struct quaternion_Rotation_matrix{
	float one_one;    float one_two;    float one_three;
	float two_one;    float two_two;    float two_three;
	float three_one;  float three_two;  float three_three;
};

struct euler_angles{
	float phi;
	float theta;
	float psi;
};

struct attitude_int{
	int32_t roll;
	int32_t pitch;
	int32_t yaw;
};

struct quaternion_int{
	int32_t eta;
	int32_t eps1;
	int32_t eps2;
	int32_t eps3;
};

//*****************************************************************



//**********************   GLOBAL VARIABLES  **********************

struct quaternion q_hat = {1, 0, 0, 0};

float k_acc = 1; //0.55;                                    //vex accelerometer estimate gain
float k_mag = 0.55;                                    //vex magnetometer  estimate gain
                
float Kp    = 1;                                          //observer proportional gain
float Ki    = 0.008;                                          //observer integral gain

struct Euler_quat_storage_struct q_hat_stored_euler;
struct Euler_vector_storage_struct b_hat_stored_euler;
												

int timestep = 0;


struct vector local_mag;

//*****************************************************************




//*******************   FORWARD EULER quaternion  *******************
struct quaternion Forward_euler_quat_integration(struct quaternion *q_dot, float h) {
	h = 0.01;
	q_hat_stored_euler.eta  = q_hat_stored_euler.eta  + h*q_dot->eta;
	q_hat_stored_euler.eps1 = q_hat_stored_euler.eps1 + h*q_dot->eps1;
	q_hat_stored_euler.eps2 = q_hat_stored_euler.eps2 + h*q_dot->eps2;
	q_hat_stored_euler.eps3 = q_hat_stored_euler.eps3 + h*q_dot->eps3;
	
	struct quaternion q_prev_return = {q_hat_stored_euler.eta, q_hat_stored_euler.eps1, q_hat_stored_euler.eps2, q_hat_stored_euler.eps3};
	
	return q_prev_return;
}
//*****************************************************************

//*******************   FORWARD EULER vector  *********************
struct vector Forward_euler_vector_integration(struct vector *b_dot, float h) {
	
	h = 0.01;
	
	b_hat_stored_euler.x = b_hat_stored_euler.x + h*b_dot->x;
	b_hat_stored_euler.y = b_hat_stored_euler.y + h*b_dot->y;
	b_hat_stored_euler.z = b_hat_stored_euler.z + h*b_dot->z;
	
	struct vector b_prev_return = {b_hat_stored_euler.x, b_hat_stored_euler.y, b_hat_stored_euler.z};
	
	return b_prev_return;
}
//*****************************************************************

//Normalizes the accelerometer and magnetometer data
struct vector normalize_vec(struct vector *a){
    
    float a_length = sqrt(a->x * a->x + a->y * a->y + a->z * a->z);
    
    struct vector a_norm;
    
    a_norm.x = (a->x)/a_length;
    a_norm.y = (a->y)/a_length;
    a_norm.z = (a->z)/a_length;

    return a_norm;
}

//The vex algorithm (acc_normalized, mag_local, mag_normalized and q_hat as arguments)
struct vector vex(struct vector *a_n, struct vector *m_l, struct vector *m_n, struct quaternion *q){
    
    struct vector w_mes;             //return vector
    
    struct vector a_hat;             //estimated accelerometer measurement
    struct vector m_hat;             //estimated magnetometer measurement
    
    a_hat.x =     2 * ( q->eps1 * q->eps3  -  q->eps2 * q->eta  );
    a_hat.y =     2 * ( q->eps2 * q->eps3  +  q->eps1 * q->eta  );
    a_hat.z = 1 - 2 * ( q->eps1 * q->eps1  +  q->eps2 * q->eps2 );
    
    m_hat.x = (1 - 2 * (q->eps2 * q->eps2 + q->eps3 * q->eps3)) * m_l->x  +      (2 * (q->eps1 * q->eps2 + q->eps3 * q->eta))  * m_l->y  +      (2 * (q->eps1 * q->eps3 - q->eps2 * q->eta))   * m_l->z;
    m_hat.y =     (2 * (q->eps1 * q->eps2 - q->eps3 * q->eta))  * m_l->x  +  (1 - 2 * (q->eps1 * q->eps1 + q->eps3 * q->eps3)) * m_l->y  +      (2 * (q->eps2 * q->eps3 + q->eps1 * q->eta))   * m_l->z;
    m_hat.z =     (2 * (q->eps1 * q->eps3 + q->eps2 * q->eta))  * m_l->x  +      (2 * (q->eps2 * q->eps3 - q->eps1 * q->eta))  * m_l->y  +  (1 - 2 * (q->eps1 * q->eps1 + q->eps2 * q->eps2))  * m_l->z;
    
    w_mes.x = -k_acc * (a_n->z * a_hat.y - a_n->y * a_hat.z)  -  k_mag * (m_n->z * m_hat.y - m_n->y * m_hat.z);
    w_mes.y = -k_acc * (a_n->x * a_hat.z - a_n->z * a_hat.x)  -  k_mag * (m_n->x * m_hat.z - m_n->z * m_hat.x);
    w_mes.z = -k_acc * (a_n->y * a_hat.x - a_n->x * a_hat.y)  -  k_mag * (m_n->y * m_hat.x - m_n->x * m_hat.y);
    
    return w_mes;
}

//Multiply omega_mes with Ki gain
struct vector w_mes_Ki_gain(struct vector *w){
    
    struct vector Bi_dot;
    
    Bi_dot.x = w->x * (-Ki);
    Bi_dot.y = w->y * (-Ki);
    Bi_dot.z = w->z * (-Ki);
    
    return Bi_dot;
}

//Sum Gyroscope, Integral- and proportional-gain
struct vector sum_Gyr_Bi_Bp(struct vector *gyr, struct vector *Bi, struct vector *Bp){
    
    struct vector omega;
    
    omega.x = gyr->x - Bi->x + ( Bp->x ) * Kp;
    omega.y = gyr->y - Bi->y + ( Bp->y ) * Kp;
    omega.z = gyr->z - Bi->z + ( Bp->z ) * Kp;
    
    return omega;
}

//Generates q_hat_dot
struct quaternion q_hat_dot_generate(struct vector *w, struct quaternion *q){
    
    struct quaternion q_hat_dot;
    
    q_hat_dot.eta  = - 0.5 * (  (w->x) * (q->eps1) + (w->y) * (q->eps2) + (w->z) * (q->eps3));
    q_hat_dot.eps1 =   0.5 * (  (w->x) * (q->eta)  - (w->y) * (q->eps3) + (w->z) * (q->eps2));
    q_hat_dot.eps2 =   0.5 * (  (w->x) * (q->eps3) + (w->y) * (q->eta)  - (w->z) * (q->eps1));
    q_hat_dot.eps3 =   0.5 * ( -(w->x) * (q->eps2) + (w->y) * (q->eps1) + (w->z) * (q->eta) );
    
    return q_hat_dot;
}

//Normalizes the quaternion
struct quaternion normalize_q(struct quaternion *q){
    
    float q_length = sqrt(q->eta * q->eta + q->eps1 * q->eps1 + q->eps2 *  q->eps2 + q->eps3 *  q->eps3);
    
    struct quaternion q_norm;
    
    q_norm.eta =  (q->eta )/q_length;
    q_norm.eps1 = (q->eps1)/q_length;
    q_norm.eps2 = (q->eps2)/q_length;
    q_norm.eps3 = (q->eps3)/q_length;
    
    return q_norm;
}

//quaternion to euler angles in degrees
struct euler_angles q2euler(struct quaternion *q){
	
	struct quaternion_Rotation_matrix R;
	
	R.one_one = (1 - 2 * (q->eps2 * q->eps2 + q->eps3 * q->eps3));      R.one_two =     (2 * (q->eps1 * q->eps2 - q->eps3 * q->eta));        R.one_three =       (2 * (q->eps1 * q->eps3 + q->eps2 * q->eta));
	R.two_one =     (2 * (q->eps1 * q->eps2 + q->eps3 * q->eta));       R.two_two = (1 - 2 * (q->eps1 * q->eps1 + q->eps3 * q->eps3));       R.two_three =       (2 * (q->eps2 * q->eps3 - q->eps1 * q->eta));
	R.three_one =   (2 * (q->eps1 * q->eps3 - q->eps2 * q->eta));       R.three_two =   (2 * (q->eps2 * q->eps3 + q->eps1 * q->eta));        R.three_three = (1 - 2 * (q->eps1 * q->eps1 + q->eps2 * q->eps2));
	
	float phi   = atan2f (R.three_two,R.three_three) * 180 / PI;
	float theta = -asinf(R.three_one) * 180 / PI;
	float psi   = atan2f(R.two_one,R.one_one)  * 180 / PI;
	
struct euler_angles attitude = {phi, theta, psi};

return attitude;
}


//System startup with initializations loading screen etc.
static void boot_up(){
		
		sensor_platform_init();
		sensor_attach(&accelerometer, SENSOR_TYPE_ACCELEROMETER, 0, 0);
		sensor_attach(&gyroscope, SENSOR_TYPE_GYROSCOPE, 0, 0);
		sensor_attach(&compass, SENSOR_TYPE_COMPASS, 0, 0);
		
}

static struct vector gyroscope_readout(){
		gyr_data.scaled = true;
		sensor_read(&gyroscope, SENSOR_READ_ROTATION, &gyr_data);
		
		int x_gyr = gyr_data.axis.x;
		int y_gyr = gyr_data.axis.y;
		int z_gyr = gyr_data.axis.z;
		
		float x_gyr_f = x_gyr;
		float y_gyr_f = y_gyr;
		float z_gyr_f = z_gyr;
		 
		struct vector gyro = {x_gyr_f*PI/180, y_gyr_f*PI/180, z_gyr_f*PI/180};
			
	return gyro; 
}

static struct vector accelerometer_readout(){
		
		sensor_read(&accelerometer, SENSOR_READ_ACCELERATION, &acc_data);
		
		int x_acc = acc_data.axis.x;
		int y_acc = acc_data.axis.y;
		int z_acc = acc_data.axis.z;
		
		float x_acc_f = x_acc;
		float y_acc_f = y_acc;
		float z_acc_f = z_acc;
		
		struct vector acc = {x_acc_f/1000, y_acc_f/1000, z_acc_f/1000};
	
	return acc;
}

static struct vector compass_readout(){
		sensor_set_bandwidth(&compass, 75 /* Hertz */);
		sensor_read(&compass, SENSOR_READ_FIELD, &mag_data);
		
		int x_mag = mag_data.axis.x;
		int y_mag = mag_data.axis.y;
		int z_mag = mag_data.axis.z;
		
		float x_mag_f = x_mag;
		float y_mag_f = y_mag;
		float z_mag_f = z_mag;
		
		struct vector mag = {x_mag_f, y_mag_f, z_mag_f};
	
	return mag;
}


static void prompt_user(char *prompt_string)
{
	/* Output prompt string */
	printf("%s\r\n", prompt_string);
    
	/* Wait for user to push button before continuing */
	LED_Off(ALL_LEDS);
    
	/* Just blink LED until button is pushed */
	while (!SWITCH_PRESSED) {
		LED_Toggle(PROMPT_LED);
		delay_ms(100);
	}
    
	LED_Off(PROMPT_LED);
    
	/* Wait until button is released */
	while (SWITCH_PRESSED) {
	}
}



struct vector calibrate_compass(){
    /* Wait for user to press button to start */
	prompt_user("Press button to start");
	
	
    
	/* Set sensor data output formats (for display after calibration
	 * is complete)
	 */
    
	/* Perform calibration sequence */
    
	/* Step 1 */
	prompt_user("Lay board flat & press button");
	(void)sensor_calibrate(&compass, MANUAL_CALIBRATE, 1, NULL);
    
	/* Step 2 */
	prompt_user("Rotate 180 degrees & press button");
	(void)sensor_calibrate(&compass, MANUAL_CALIBRATE, 2, NULL);
    
	/* Step 3 */
	prompt_user("Flip board & press button");
	if (sensor_calibrate(&compass, MANUAL_CALIBRATE, 3, NULL) == false) {
		if (compass.err == SENSOR_ERR_IO) {
			printf("Calibration failure: write error\n\r");
		} else {
			printf("Unknown error while calibrating device\n\r");
		}
        
		while (true) {
			/* Error occurred, loop forever */
		}
	}
}





int main(void)
{
    board_init();
	boot_up();
	
	//NED magnetic reference for magnetometer in Trondheim
    calibrate_compass();
    local_mag.y = 13.5961;		//Algning Y with North
    local_mag.x = 0.5467;		//Aligning X with East
    local_mag.z = -49.9338;		//Aligning Z with negative Down
    
    struct vector local_mag_norm = normalize_vec(&local_mag);
    
    //Initializing integrator
    q_hat_stored_euler.eta = 1;
    q_hat_stored_euler.eps1 = 0;
    q_hat_stored_euler.eps2 = 0;
    q_hat_stored_euler.eps3 = 0;
    q_hat_stored_euler.timestamp = 0;
    
    b_hat_stored_euler.x = 0;
    b_hat_stored_euler.y = 0;
    b_hat_stored_euler.z = 0;
    b_hat_stored_euler.timestamp = 0;
	
	q_hat.eta = 1;
	q_hat.eps1 = 0;
	q_hat.eps2 = 0;
	q_hat.eps3 = 0;
	
	float time = 0;
    
	int stream_count = 0;
	
	printf("Push button when ready \n");
	printf("Time \t");
	printf("eta \t");
	printf("eps1 \t");
	printf("eps2 \t");
	printf("eps3 \t");
	printf("bias X \t");
	printf("bias Y \t");
	printf("bias Z \n");
	
	
	int led_index = 0;
	
	do {
		/* Just blink LED until button is pushed */
		LED_On(PROMPT_LED);

		//delay_ms(500);
	} while (!SWITCH_PRESSED);

	while (true) {
	
		float tsc = cpu_cy_2_us(Get_system_register(AVR32_COUNT), sysclk_get_cpu_hz());
		float stepsize = tsc/1000000;
		time = time + stepsize;
		Set_system_register(AVR32_COUNT, 0);	
		
		
		/*************	STEP 1 *************/
		//Read and store gyroscope sensor data
		struct vector gyr = gyroscope_readout();
		
		//Read and store and accelerometer sensor data
		struct vector acc = accelerometer_readout();
		
		//Read and store  magnetometer sensor data
		struct vector mag = compass_readout();
		
		//Normalize sensor data
		struct vector acc_norm  = normalize_vec(&acc);
		struct vector mag_norm  = normalize_vec(&mag);
		
		/*************	STEP 2 *************/
		//Vex algorithm
		struct vector omega_mes = vex(&acc_norm, &local_mag_norm, &mag_norm, &q_hat);
		
		/*************	STEP 3 *************/
		//Gaining w_mes output with Ki to create Bi_dot
		struct vector bias_dot = w_mes_Ki_gain(&omega_mes);
		
		/*************	STEP 4 *************/
		//Numerically integrate Bi_dot
		//struct vector bias = RungeKutta_3D_integration(&Bi_stored, &bias_dot);
		struct vector bias = Forward_euler_vector_integration(&bias_dot, stepsize);
		
		/*************	STEP 5 *************/
		//Creating the sum of Gyroscope, Bi and Omega_mes
		struct vector injection = sum_Gyr_Bi_Bp(&gyr, &bias, &omega_mes);
		
		/*************	STEP 6 *************/
		//Creating the q_hat_dot with the T(q) matrix
		struct quaternion q_hat_dot = q_hat_dot_generate(&injection, &q_hat);
		
		/*************	STEP 7 *************/
		//Numerically integrate q_hat_dot with feedback from q_hat
		q_hat = Forward_euler_quat_integration(&q_hat_dot, stepsize);
		//q_hat = RungeKutta_quat_integration(&q_hat_stored, &q_hat_dot);
		
		/*************	STEP 8 *************/
		//Normalizing the quaternion
		q_hat = normalize_q(&q_hat);

		
	
		
if ( stream_count == 10 ){
	
		struct euler_angles att = q2euler(&q_hat);
		printf("%f \t", time);
		
		printf("%f \t", att.phi);
		printf("%f \t", att.theta);
		printf("%f \t", att.psi);
		
		printf("%f \t", bias.x*180/PI);
		printf("%f \t", bias.y*180/PI);
		printf("%f \t", bias.z*180/PI);
		
		printf("%f \n", stepsize);
		
		stream_count = 0;
}else{
	stream_count++;
}			
		

    }	
}
