#ifndef _SENSOR_DEMO_H_
#define _SENSOR_DEMO_H_

#include <stdio.h>
#include <asf.h>
#include <led.h>
#include <sensor.h>
#include <math.h>

/* Hardware Environment Constants */
#define CHARS_PER_LINE      (LCD_WIDTH_PIXELS  / SYSFONT_WIDTH)
#define LINES_PER_SCREEN    (LCD_HEIGHT_PIXELS / SYSFONT_LINESPACING)

#define PROMPT_LED          (LED0)
#define ALL_LEDS            (LED0 | LED1 | LED2 | LED3)

#define REFRESH_PERIOD      (2 /* Hertz */)
#define SW1                 (GPIO_PUSH_BUTTON_1)
#define SW2					(GPIO_PUSH_BUTTON_2)

/* Convenience Macros */
#define radians(a)          (DEG_TO_RAD * (a))
#define hz_to_ms(hz)        ((unsigned long)((1000 / (hz)) + 0.5))

#define switch_pressed(sw)  (ioport_get_value(sw) == false)

#define clear_screen()  gfx_mono_draw_filled_rect \
(0, 0, LCD_WIDTH_PIXELS, LCD_HEIGHT_PIXELS, GFX_PIXEL_CLR)

#define screen_border() gfx_mono_draw_rect \
(0, 0, LCD_WIDTH_PIXELS, LCD_HEIGHT_PIXELS, GFX_PIXEL_SET)

#define PI (3.141592653589793)

#define 	J4_PIN0   IOPORT_CREATE_PIN(PORTE, 0)


#define 	CONF_BOARD_ENABLE_USARTC0

#endif
