clc
clear all
filename = 'UC3LoggedAttitude.txt';
A = importdata(filename);
%time = (A.data(:,1) - A.data(1,1));
%
% i = 1;
% j = 1;
% while j<=length(A.data(:,1)),
%    q = [A.data(j,2); A.data(j,3); A.data(j,4); A.data(j,5)];
%    %q=q/norm(q);
%    [phi,theta,psi] = q2euler(q);
%    attitude = [(A.data(j,1) - A.data(1,1)), phi*(180/pi), theta*(180/pi), psi*(180/pi)];
%    attitudeplot(i,:) = attitude;
%    j = j+4;
%    i = i+1;
% end

set(0,'DefaultAxesFontSize',22)
figure(1); clf
subplot(3,1,1), plot(A.data(:,1), A.data(:,2))
legend('Roll')
title('Embedded microcontroller attitude estimate')
grid
ylabel('degrees')

subplot(3,1,2), plot(A.data(:,1), A.data(:,3))
legend('Pitch')
grid
ylabel('degrees')

subplot(3,1,3), plot(A.data(:,1), A.data(:,4))
legend('Yaw')
grid

xlabel('seconds')
ylabel('degrees')

figure(2); clf
subplot(3,1,1), plot(A.data(:,1), A.data(:,5))
legend('Roll')
title('Embedded microcontroller bias estimate')
grid
ylabel('degrees/s')

subplot(3,1,2), plot(A.data(:,1), A.data(:,6))
legend('Pitch')
grid
ylabel('degrees/s')

subplot(3,1,3), plot(A.data(:,1), A.data(:,7))
legend('Yaw')
grid

xlabel('seconds')
ylabel('degrees/s')

figure(3); clf

plot(A.data(:,1), 1./A.data(:,8))
title('Filter frequency')
grid
xlabel('seconds')
ylabel('Hz')


figure(4); clf
plot(A.data(:,1), A.data(:,2), A.data(:,1), A.data(:,3), A.data(:,1), A.data(:,4))
xlabel('seconds')
ylabel('degrees')
title('Attitude in degrees')
legend('roll','pitch','yaw')


